// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "util/random.hpp"
#include "scene/components/physics/2d/CharacterController2D.hpp"

namespace Dawn {
  class EntityRandomWalk : public SceneItemComponent {
    protected:
      CharacterController2D *characterController = nullptr;

    public:
      // @optional
      float_t timeLeftUntilNextDecision = 0.0f;
      // @optional
      float_t moveSpeed = 30.0f;
      // @optional
      glm::vec2 destination = glm::vec2(0, 0);
      // @optional
      glm::vec2 walkRange = glm::vec2(12.0f, 12.0f);

      EntityRandomWalk(SceneItem* item);
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}